/*
 * Car.java
 *
 * Created on April 21, 2006, 5:32 PM
 */

package com.sun.jbi.blueprints.insuranceClaim.common;

import java.beans.*;
import java.io.Serializable;

/**
 * @author Graj
 */
public class Car extends Object implements Serializable {
    
    public static final String MAKE_PROPERTY = "make";
    public static final String MODEL_PROPERTY = "model";
    public static final String YEAR_PROPERTY = "year";

    private String make;

    private String model;

    private int year;
    
    private PropertyChangeSupport propertySupport;
    
    public Car() {
        propertySupport = new PropertyChangeSupport(this);
    }
    
    public void setSampleProperty(String value) {
    }
    
    
    public void addPropertyChangeListener(PropertyChangeListener listener) {
        propertySupport.addPropertyChangeListener(listener);
    }
    
    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertySupport.removePropertyChangeListener(listener);
    }

    public String getMake() {
        return make;
    }

    public void setMake(String value) {
        String oldValue = this.make;
        this.make = value;
        propertySupport.firePropertyChange(MAKE_PROPERTY, oldValue, this.make);
    }

    public String getModel() {
        return model;
    }

    public void setModel(String value) {
        String oldValue = this.model;
        this.model = value;
        propertySupport.firePropertyChange(MODEL_PROPERTY, oldValue, this.model);
    }

    public int getYear() {
        return year;
    }

    public void setYear(int value) {
        int oldValue = this.year;
        this.year = value;
        propertySupport.firePropertyChange(YEAR_PROPERTY, oldValue, this.year);
    }
    
    public String getUniqueString() {
        String uniqueString = this.make+"_"+this.model+"_"+this.year;
        System.out.println("Car Unique String is: "+uniqueString);
        return uniqueString;
    }
    
}
