/*
 * FileClaimRequest.java
 *
 * Created on April 21, 2006, 5:33 PM
 */

package com.sun.jbi.blueprints.insuranceClaim.common;

import java.beans.*;
import java.io.Serializable;

/**
 * @author Graj
 */
public class FileClaimRequest extends Object implements Serializable {
    
    public static final String CUSTOMERID_PROPERTY = "customerId";
    public static final String CAR_PROPERTY = "car";
    public static final String DESCRIPTION_PROPERTY = "description";
    
    private String customerId;
    private Car car;
    private String description;
    
    private PropertyChangeSupport propertySupport;
    
    public FileClaimRequest() {
        propertySupport = new PropertyChangeSupport(this);
    }
    
    public void addPropertyChangeListener(PropertyChangeListener listener) {
        propertySupport.addPropertyChangeListener(listener);
    }
    
    public void removePropertyChangeListener(PropertyChangeListener listener) {
        propertySupport.removePropertyChangeListener(listener);
    }

    public String getCustomerId() {
        return customerId;
    }

    public void setCustomerId(String value) {
        String oldValue = this.customerId;
        this.customerId = value;
        propertySupport.firePropertyChange(CUSTOMERID_PROPERTY, oldValue, this.customerId);
    }

    public Car getCar() {
        return car;
    }

    public void setCar(Car value) {
        Car oldValue = this.car;
        this.car = value;
        propertySupport.firePropertyChange(CAR_PROPERTY, oldValue, this.car);
    }

    public String getDescription() {
        return description;
    }

    public void setDescription(String value) {
        String oldValue = this.description;
        this.description = value;
        propertySupport.firePropertyChange(DESCRIPTION_PROPERTY, oldValue, this.description);
    }

    public String getUniqueString() {
        String uniqueString = this.customerId+"::"+this.car.getUniqueString()+"::"+this.description;
        return uniqueString;
    }
}
